# IRdUITable Interface Reference

Inherits IRsDataObject.

List of all members.

## Public Member Functions
HRESULT | GetAllAspects ([out] LPSAFEARRAY *saAspects)
HRESULT | AddControl ([in] IRsUIControl *pControl,[in] RECT rcControl,[in] RtUlong ulAspect,[in]RtUITableRecord *defaults)
HRESULT | AddRecord ([in] RtUITableRecord *sRecord,[in] RtUlong ulAspect)
HRESULT | ReplaceControl ([in] IRsUIControl *pOldControl,[in] RECT rcOldControl,[in] IRsUIControl *pNewControl,[in] RECT rcNewControl,[in] RtUlong ulAspect)
HRESULT | ReplaceRecord ([in] RtUlong ulAspect,[in] RtUlong ulIndex,[in] RtUITableRecord *sNewRecord)
HRESULT | SetBkgColor ([in] COLORREF col,[in] RtUlong ulAspect)
HRESULT | RemoveBkgColor ([in] RtUlong ulAspect)
HRESULT | RemoveControl ([in] RtUlong ulAspect,[in] RtUlong ulIndex)
HRESULT | RemoveRecord ([in] RtUITableRecord *sRecord,[in] RtUlong ulAspect)
HRESULT | RemoveAspect ([in] RtUlong ulAspect)
HRESULT | GetControl ([in] RtUlong ulAspect,[in] RtUlong ulIndex,[out] RtUITableRecord *sRecords)
HRESULT | GetControlsCount ([in] RtUlong ulAspect,[out] RtUlong *ulRecCount)
HRESULT | GetBoundingRect ([in] RtUlong ulAspect,[out] RECT *rcBound)
HRESULT | GetLastAspect ([out] RtUlong *ulAspect)
HRESULT | GetBkgColor ([in] RtUlong ulAspect,[out] COLORREF *col)
HRESULT | Clear (void)
HRESULT | SetLastAspect ([in] RtUlong ulAspect)
HRESULT | AddAspectName ([in] RtUlong ulAspect,[in] BSTR bsName)
HRESULT | GetAspectName ([in] RtUlong ulAspect,[out, retval] BSTR *bsName)
HRESULT | SetFlags ([in] RtFlags fFlags)
HRESULT | GetFlags ([out, retval] RtFlags *pFlags)
HRESULT | CopyAspectDef ([in] RtUlong dwSrcIdx,[in] RtUlong dwDstIdx)
HRESULT | ValidateVersion (void)
HRESULT | GetAspectIndex ([in] BSTR bsName,[out, retval] RtUlong *pulAspect)
HRESULT | GetUiTableVersion ([out, retval] RtUlong *pdwVersion)
HRESULT | SwitchExportedAspectState ([in] RtUlong uAspect)
HRESULT | GetExportedAspectState ([in] RtUlong uAspect,[out, retval] RtBool *bState)
HRESULT | GetExportedPanelCount ([out, retval] RtUlong *puCount)
HRESULT | AddExportedPanelInfo ([in] RtExportedPanelInfo sExportInfo)
HRESULT | GetExportedPanelInfo ([out, retval] RtExportedPanelInfo *psExportInfo)
HRESULT | SetExportedPanelInfo ([in] RtExportedPanelInfo sExportInfo)
HRESULT | GetExportedPanelInfoItem ([in] RtUlong uIndex,[out, retval] RtExportedPanelInfo *psExportInfo)
HRESULT | SetExportedPanelInfoItem ([in] RtUlong uIndex,[in] RtExportedPanelInfo sExportInfo)

## Detailed Description

The IRdUITable interface provides methods that allow you work with UI table.

## Member Function Documentation

HRESULT IRdUITable::GetAllAspects | ( | [out] LPSAFEARRAY * | saAspects | ) |

Get all LE panel aspects names array.

Parameters:

  | saAspects | [out] Pointer to a variable of type LPSAVEARRAY, that retrieves all aspects of LE panel.

HRESULT IRdUITable::AddControl | ( | [in] IRsUIControl * | pControl,
|  | [in] RECT | rcControl,
|  | [in] RtUlong | ulAspect,
|  | [in] RtUITableRecord * | defaults |
| ) |  |  |

Add control to UI table.

Parameters:

  | pControl | [in] UI control interface.
  | rcControl | [in] Current UI control position.
  | ulAspect | [in] The active aspect.
  | defaults | [in] UI table records.

HRESULT IRdUITable::AddRecord | ( | [in] RtUITableRecord * | sRecord,
|  | [in] RtUlong | ulAspect |
| ) |  |  |

Add record to UI table for aspect.

Parameters:

  | sRecord | [in] New record.
  | ulAspect | [in] Index of aspect that will be contain new record.

Returns:
  E_FAIL if new record exist for apect.

  S_OK otherwise, record is added.

HRESULT IRdUITable::ReplaceControl | ( | [in] IRsUIControl * | pOldControl,
|  | [in] RECT | rcOldControl,
|  | [in] IRsUIControl * | pNewControl,
|  | [in] RECT | rcNewControl,
|  | [in] RtUlong | ulAspect |
| ) |  |  |

Replace old control with new one.

- Old control is removed.
- New control is added.
- Both controls belong to specified aspect.

Parameters:

  | pOldControl | [in] Old control.
  | rcOldControl | [in] Current position of old control.
  | pNewControl | [in] New control.
  | rcNewControl | [in] Current position of new control.
  | ulAspect | [in] Index of aspect that contains old and new controls.

HRESULT IRdUITable::ReplaceRecord | ( | [in] RtUlong | ulAspect,
|  | [in] RtUlong | ulIndex,
|  | [in] RtUITableRecord * | sNewRecord |
| ) |  |  |

Replace record of control specified by index that belong to the specified aspect.

Parameters:

  | ulAspect | [in] Index of aspect that contain control.
  | ulIndex | [in] Index of control that will be replaced.
  | sNewRecord | [in] New record for control.

HRESULT IRdUITable::SetBkgColor | ( | [in] COLORREF | col,
|  | [in] RtUlong | ulAspect |
| ) |  |  |

Add aspect background color.

Parameters:

  | COLORREF | col [in] color.
  | ulAspect | [in] The active aspect.

HRESULT IRdUITable::RemoveBkgColor | ( | [in] RtUlong | ulAspect | ) |

Remove background color entry.

Parameters:

  | ulAspect | [in] The active aspect.

HRESULT IRdUITable::RemoveControl | ( | [in] RtUlong | ulAspect,
|  | [in] RtUlong | ulIndex |
| ) |  |  |

Remove control from aspect.

Parameters:

  | ulAspect | [in] Index of aspect that contain control.
  | ulIndex | [in] Index of control that will be removed.

HRESULT IRdUITable::RemoveRecord | ( | [in] RtUITableRecord * | sRecord,
|  | [in] RtUlong | ulAspect |
| ) |  |  |

Remove record from aspect.

Parameters:

  | sRecord | [in] Pointer to the record structure that will be removed.
  | ulAspect | [in] Index of aspect that contain record.

HRESULT IRdUITable::RemoveAspect | ( | [in] RtUlong | ulAspect | ) |

Remove aspect.

Parameters:

  | ulAspect | [in] Index of deleted aspect.

HRESULT IRdUITable::GetControl | ( | [in] RtUlong | ulAspect,
|  | [in] RtUlong | ulIndex,
|  | [out] RtUITableRecord * | sRecords |
| ) |  |  |

Get control defined by index, from aspect specified by index.

Parameters:

  | ulAspect | [in] Index of required aspect.
  | ulIndex | [in] Index of required control of specified aspect.
  | sRecords | [out] Pointer to structure that retrieves record data of control.

HRESULT IRdUITable::GetControlsCount | ( | [in] RtUlong | ulAspect,
|  | [out] RtUlong * | ulRecCount |
| ) |  |  |

Gets controls count that belong to asked aspect.

Parameters:

  | ulAspect | [in] Index of required aspect.
  | ulRecCount | [out] Pointer to a variable of type RtUlong that retrieves count of controls that belong to asked aspect.

HRESULT IRdUITable::GetBoundingRect | ( | [in] RtUlong | ulAspect,
|  | [out] RECT * | rcBound |
| ) |  |  |

Gets bounding rectangle of specified aspect.

Parameters:

  | ulAspect | [in] Index of required aspect.
  | rcBound | [out] Pointer to a variable of type RECT that retrieves bounding rectangle of required aspect.

HRESULT IRdUITable::GetLastAspect | ( | [out] RtUlong * | ulAspect | ) |

Get last added aspect.

Parameters:

  | ulAspect | [out] Pointer to a variable of type RtUlong that retrieves index of last aspect.

HRESULT IRdUITable::GetBkgColor | ( | [in] RtUlong | ulAspect,
|  | [out] COLORREF * | col |
| ) |  |  |

Get aspect background color.

Parameters:

  | COLORREF | *col [out] color.
  | ulAspect | [in] The active aspect.

HRESULT IRdUITable::Clear | ( | void |  | ) |

Clear UI table.

HRESULT IRdUITable::SetLastAspect | ( | [in] RtUlong | ulAspect | ) |

Set last aspect.

Parameters:

  | ulAspect | [in] The new last index.

HRESULT IRdUITable::AddAspectName | ( | [in] RtUlong | ulAspect,
|  | [in] BSTR | bsName |
| ) |  |  |

Add aspect name.

Parameters:

  | ulAspect | [in] The index of aspect.
  | bsName | [in] Name added for asked aspect index.

HRESULT IRdUITable::GetAspectName | ( | [in] RtUlong | ulAspect,
|  | [out, retval] BSTR * | bsName |
| ) |  |  |

Gets name of required aspect.

Parameters:

  | ulAspect | [in] The index of required aspect.

Returns:
  bsName [out, retval] Name of required aspect.

HRESULT IRdUITable::SetFlags | ( | [in] RtFlags | fFlags | ) |

Set flags.

- Flags specify work with automatically generated aspects: default and iconize.

Parameters:

  | fFlags | [in] New flags. See possible values of flags: UITABLE_FLG_DEFAULT_EDITED - for default aspect. UITABLE_FLG_ICONIZED_EDITED - for iconized aspet.

HRESULT IRdUITable::GetFlags | ( | [out, retval] RtFlags * | pFlags | ) |

Get flags.

- Flags specify work with automatically generated aspects: default and iconize.

Returns:
  pFlags [out, retval] Variable of type RtFlags that retrieves actual flags. See possible values of flags:
  - UITABLE_FLG_DEFAULT_EDITED - for default aspect.
  - UITABLE_FLG_ICONIZED_EDITED - for iconized aspet.

HRESULT IRdUITable::CopyAspectDef | ( | [in] RtUlong | dwSrcIdx,
|  | [in] RtUlong | dwDstIdx |
| ) |  |  |

Copy aspect from index specified with parameter dwSrcIdx, to aspect specified with dwDstInx index.

Parameters:

  | dwSrcIdx | [in] Source aspect index.
  | dwDstIdx | [in] Destination aspect index.

HRESULT IRdUITable::ValidateVersion | ( | void |  | ) |

Validate stream version.

HRESULT IRdUITable::GetAspectIndex | ( | [in] BSTR | bsName,
|  | [out, retval] RtUlong * | pulAspect |
| ) |  |  |

Get index of aspect defined by its name.

Parameters:

  | bsName | [in] LE panel aspect name.

Returns:
  pulAspect [out, retval] Pointer on variable that retrieves aspect index.

HRESULT IRdUITable::GetUiTableVersion | ( | [out, retval] RtUlong * | pdwVersion | ) |

Return current version of UI table.

Returns:
  pdwVersion [out, retval] Pointer on variable that retrieves current version of UI table.

HRESULT IRdUITable::SwitchExportedAspectState | ( | [in] RtUlong | uAspect | ) |

Switch exported aspect of LE panel window state for specified aspect.

Parameters:

  | uAspect | [in] Specified aspect index which export state will be switched.

HRESULT IRdUITable::GetExportedAspectState | ( | [in] RtUlong | uAspect,
|  | [out, retval] RtBool * | bState |
| ) |  |  |

Get exported aspect state of LE panel window.

Parameters:

  | uAspect | [in] Specified index of aspect LE panel which export state will be received.

Returns:
  bState [out, retval] Pointer to a variable that retrieves exported aspect state.

HRESULT IRdUITable::GetExportedPanelCount | ( | [out, retval] RtUlong * | puCount | ) |

Get count of exported aspects of LE panel window.

Returns:
  puCount [out, retval] Pointer to a variable that retrieves exported aspects count for LE panel.

HRESULT IRdUITable::AddExportedPanelInfo | ( | [in] RtExportedPanelInfo | sExportInfo | ) |

Add info of exported aspect of LE panel window.

Parameters:

  | sExportInfo | [in] Information about LE panel aspect export.

HRESULT IRdUITable::GetExportedPanelInfo | ( | [out, retval] RtExportedPanelInfo * | psExportInfo | ) |

Get informations of exported aspect of LE panel window.

Returns:
  psExportInfo [out, retval] Pointer to structure that retrieves information about aspect export of LE panel.

HRESULT IRdUITable::SetExportedPanelInfo | ( | [in] RtExportedPanelInfo | sExportInfo | ) |

Set informations of exported aspect of LE panel window.

Parameters:

  | sExportInfo | [in] Information about LE panel aspect export.

HRESULT IRdUITable::GetExportedPanelInfoItem | ( | [in] RtUlong | uIndex,
|  | [out, retval] RtExportedPanelInfo * | psExportInfo |
| ) |  |  |

Get information about exported aspect of LE panel window according to its index in array of exported panel info.

Parameters:

  | uIndex | [in] Index in array of exported panel info.

Returns:
  psExportInfo [out, retval] Pointer to structure that retrieves information about exported aspect of LE panel window according to its index in array of exported panel info.

HRESULT IRdUITable::SetExportedPanelInfoItem | ( | [in] RtUlong | uIndex,
|  | [in] RtExportedPanelInfo | sExportInfo |
| ) |  |  |

Set informations of exported aspect of LE panel window according to its index in array of exported panel info.

Parameters:

  | uIndex | [in] Index in array of exported panel info.
  | sExportInfo | [in] Structure that contain informations about exported aspect of LE panel window according to its index in array of exported panel info